#include <luna/Alloc.h>

#ifndef USE_FREESTANDING
#include <stdlib.h>
#endif

[[nodiscard]] void* raw_malloc(usize size)
{
#ifdef USE_FREESTANDING
    char* const rc = new char[size];
    return (void*)rc;
#else
    return malloc(size);
#endif
}

void raw_free(void* ptr)
{
#ifdef USE_FREESTANDING
    char* const arr = (char*)ptr;
    delete[] arr;
#else
    return free(ptr);
#endif
}